#ifndef _DMAC_H_
#define _DMAC_H_

#include "Types.h"
#include "Stream.h"

class CDMAC
{
public:
	enum REGISTER
	{
		D2_CHCR	= 0x1000A000,
		D2_MADR	= 0x1000A010,
		D2_SIZE = 0x1000A020,
		
		D5_CHCR = 0x1000C000,
		D5_MADR = 0x1000C010,
		D5_QWC	= 0x1000C020,

		D6_CHCR = 0x1000C400,
		D6_MADR	= 0x1000C410,
		D6_QWC	= 0x1000C420,
		D6_TADR = 0x1000C430,

		D_STAT	= 0x1000E010,
	};

	static void			Reset();

	static uint32		GetRegister(uint32);
	static void			SetRegister(uint32, uint32);

	static void			LoadState(Framework::CStream*);
	static void			SaveState(Framework::CStream*);

	static void			DisassembleGet(uint32);
	static void			DisassembleSet(uint32, uint32);

	static bool			IsInterruptPending();

private:
	static uint32		m_D_STAT;

	static uint32		m_D2_CHCR;
	static uint32		m_D2_MADR;
	static uint32		m_D2_SIZE;

	static uint32		m_D5_CHCR;
	static uint32		m_D5_MADR;
	static uint32		m_D5_QWC;

	static uint32		m_D6_CHCR;
	static uint32		m_D6_MADR;
	static uint32		m_D6_QWC;
	static uint32		m_D6_TADR;
};

#endif
