#include <stdio.h>
#include "GIF.h"
#include "uint128.h"
#include "PS2VM.h"

uint16	CGIF::m_nLoops = 0;
uint8	CGIF::m_nCmd = 0;

void CGIF::Reset()
{
	m_nLoops = 0;
	m_nCmd = 0;
}

void CGIF::ExecuteDMA(uint32 nAddress, uint32 nSize)
{
	uint128 nPacket;
	uint32 nEnd;
	if(CPS2VM::m_Logging.GetGSLoggingStatus())
	{
		printf("GIF: Processed display list at 0x%0.8X.\r\n", nAddress);
	}
	nEnd = nAddress + nSize;
	while(nAddress < nEnd)
	{
		if(m_nLoops == 0)
		{
			nPacket.nV[0] = CPS2VM::m_EE.m_pMemoryMap->GetWord(nAddress + 0x0);
			nPacket.nV[1] = CPS2VM::m_EE.m_pMemoryMap->GetWord(nAddress + 0x4);
			nPacket.nV[2] = CPS2VM::m_EE.m_pMemoryMap->GetWord(nAddress + 0x8);
			nPacket.nV[3] = CPS2VM::m_EE.m_pMemoryMap->GetWord(nAddress + 0xC);
			nAddress += 0x10;

			m_nLoops	= (uint16)(nPacket.nV0 & 0x7FFF);
			m_nCmd		= (uint8)(nPacket.nV1 >> 24) & 0xF;
		}
		else
		{
			switch(m_nCmd)
			{
			case 0x0:
				//GIFPACKED
				nPacket.nV[0] = CPS2VM::m_EE.m_pMemoryMap->GetWord(nAddress + 0x0);
				nPacket.nV[1] = CPS2VM::m_EE.m_pMemoryMap->GetWord(nAddress + 0x4);
				nPacket.nV[2] = CPS2VM::m_EE.m_pMemoryMap->GetWord(nAddress + 0x8);
				nPacket.nV[3] = CPS2VM::m_EE.m_pMemoryMap->GetWord(nAddress + 0xC);
				nAddress += 0x10;
				CPS2VM::m_pGS->WriteRegister((uint8)nPacket.nD1, nPacket.nD0);
				break;
			case 0x8:
				//GIFIMAGE
				CPS2VM::m_pGS->FeedImageData(CPS2VM::m_pRAM + nAddress, m_nLoops * 0x10);
				nAddress += (m_nLoops * 0x10);
				m_nLoops = 1;
				break;
			}
			m_nLoops--;
		}
	}
}
