#ifndef _IOP_PADMAN_H_
#define _IOP_PADMAN_H_

#include "IOP_Module.h"

namespace IOP
{
	class CPadMan : public CModule
	{
	public:
							CPadMan();
		virtual void		Invoke(uint32, void*, uint32, void*, uint32);
		void				SetButtonState(uint32, bool);

		enum MODULE_ID
		{
			MODULE_ID = 0x8000010F
		};

		enum BUTTONS
		{
			BUTTON_LEFT		= 0x8000,
			BUTTON_RIGHT	= 0x2000,
			BUTTON_START	= 0x0800,
			BUTTON_SELECT	= 0x0100,
			BUTTON_SQUARE	= 0x0080,
			BUTTON_CROSS	= 0x0040,
			BUTTON_CIRCLE	= 0x0020,
			BUTTON_TRIANGLE	= 0x0010,
		};

	private:
		struct PADDATA
		{
			uint32			nFrame;
			uint8			nState;
			uint8			nReqState;
			uint8			nOk;
			uint8			nReserved0;
			uint8			nData[32];
			uint32			nLenght;
			uint32			nReserved1[5];
		};

		PADDATA*			m_pPad;

		void				Open(void*, uint32, void*, uint32);
	};
}


#endif
