#ifndef _MAINWINDOW_H_
#define _MAINWINDOW_H_

#include "win32/Window.h"
#include "NiceStatus.h"
#include "OutputWnd.h"
#include "SlotHandler.h"
#ifdef DEBUGGER_INCLUDED
#include "Debugger.h"
#endif

class CMainWindow : public Framework::CWindow
{
public:
									CMainWindow(char*);
									~CMainWindow();
	int								Loop();

protected:
	long							OnTimer();
	long							OnCommand(unsigned short, unsigned short, HWND);

private:
	void							OpenELF();
	void							ResumePause();
	void							ShowDebugger();
	void							ShowSysInfo();
	void							ShowAbout();

	void							LoadELF(const char*);
	void							RefreshLayout();
	void							PrintVersion(xchar*);
	void							SetStatusText(xchar*);
	void							CreateAccelerators();
	
	void							UpdateUI();

	void							OnNewFrame(int);
	void							OnOutputWndSizeChange(int);
	void							OnExecutableChange(int);

	Framework::CSlotHandler<int>*	m_pOnOutputWndSizeChangeHandler;
	Framework::CSlotHandler<int>*	m_pOnNewFrameHandler;
	Framework::CSlotHandler<int>*	m_pOnExecutableChange;

	unsigned int					m_nFrames;
	HACCEL							m_nAccTable;

	CNiceStatus*					m_pStatusBar;
	COutputWnd*						m_pOutputWnd;
#ifdef DEBUGGER_INCLUDED
	CDebugger*						m_pDebugger;
#endif
};

#endif
