#include <string.h>
#include "Utils.h"

using namespace Framework;

void Utils::GetLine(CStream* pS, CStr* pStr)
{
	unsigned char nChar;

	(*pStr) = "";

	pS->Read(&nChar, 1);
	while(!pS->IsEOF())
	{
		if(nChar != '\r')
		{
			(*pStr) += nChar;
		}
		pS->Read(&nChar, 1);
		if(nChar == '\n') break;
	}
}

const char* Utils::GetFilenameFromPath(const char* sPath, char nSeparator)
{
	const char* sTemp;
	sTemp = strchr(sPath, nSeparator);
	while(sTemp != NULL)
	{
		sPath = sTemp + 1;
		sTemp = strchr(sPath, nSeparator);
	}
	return sPath;
}

HBITMAP Utils::CreateMask(HBITMAP nBitmap, uint32 nColor)
{
	BITMAP bm;
	HBITMAP nMask;
	HDC hDC1, hDC2;
	GetObject(nBitmap, sizeof(BITMAP), &bm);
	nMask = CreateBitmap(bm.bmWidth, bm.bmHeight, 1, 1, NULL);

	hDC1 = CreateCompatibleDC(0);
	hDC2 = CreateCompatibleDC(0);

	SelectObject(hDC1, nBitmap);
	SelectObject(hDC2, nMask);

	SetBkColor(hDC1, nColor);
	BitBlt(hDC2, 0, 0, bm.bmWidth, bm.bmHeight, hDC1, 0, 0, SRCCOPY);
	BitBlt(hDC1, 0, 0, bm.bmWidth, bm.bmHeight, hDC2, 0, 0, SRCINVERT);

	DeleteDC(hDC1);
	DeleteDC(hDC2);

	return nMask;
}
